﻿using System;
using System.Windows.Media.Media3D;
using ProjectorKit.Elements;

namespace Picture_Viewer_with_External_Buttons
{
    public class ButtonElement : ImageElement
    {
        public delegate void ClickHandler(ButtonElement element);
        public event ClickHandler OnClick = delegate { };

        protected override Type NetworkType
        {
            get
            {
                return typeof(ImageElement);
            }
        }

        public ButtonElement(Point3D position, double width, double height, string picture, ClickHandler onClick)
            : base(position, width, height, picture)
        {
            OnClick += onClick;
        }

        public void Click()
        {
            OnClick(this);
        }
    }
}
