﻿using System.Windows.Media.Media3D;

namespace ProjectorKit.Filter
{
    public class MultiFilter : AbstractFilter
    {
        private AbstractFilter filter1;
        private AbstractFilter filter2;

        /// <summary>
        /// Filters a pose with the two filters. To use more than two filters, use MultiFilter as an argument.
        /// </summary>
        /// <param name="filter1">First applied filter</param>
        /// <param name="filter2">Second applied filter</param>
        public MultiFilter(AbstractFilter filter1, AbstractFilter filter2)
        {
            this.filter1 = filter1;
            this.filter2 = filter2;
        }

        public override void Filter(Point3D position, Vector3D direction, Vector3D up)
        {
            filter1.Filter(position, direction, up);
            filter2.Filter(filter1.Position, filter1.Direction, filter1.Up);
            UpdateFilter(filter2.Position, filter2.Direction, filter2.Up);
        }
    }
}
