﻿using ProjectorKit.Elements;

namespace ProjectorKit.Tracking
{
    public interface ITracker
    {
        /// <summary>
        /// Bind the given element to the tracked object.
        /// </summary>
        /// <param name="binding">Object containing the tracking information.</param>
        void Bind(TrackerBinding binding);

        /// <summary>
        /// Bind the given element to the tracked object.
        /// </summary>
        /// <param name="name">Name of the tracked object.</param>
        /// <param name="element">Element to bind.</param>
        void BindToTrackedObject(AbstractElement element, string name);
    }
}
