﻿using System.Windows.Media.Media3D;
using GroupLab.iNetwork;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using ProjectorKit.Elements;

namespace ProjectorKitTests.World
{
    [TestClass]
    public class WorldTest
    {
        Model3DGroup modelGroup = new Model3DGroup();

        [TestMethod]
        public void TestImageElementShouldBeRecreated()
        {
            ImageElement ie = new ImageElement(new Point3D(1, 2, -3), 4, 2, "http://25.media.tumblr.com/tumblr_m3idmuTaPZ1ru894jo1_1280.png");
            Message msg = ((AbstractElement)ie).ToMessage("a");
            ImageElement ie2 = (ImageElement)AbstractElement.CreateElement(msg, modelGroup);

            Assert.AreEqual(ie.GetType(), ie2.GetType());
            Assert.AreEqual(ie.Position, ie2.Position);
            Assert.AreEqual(ie.Picture, ie2.Picture);

            Assert.AreEqual(ie.Corners.Length, ie2.Corners.Length);
            Assert.AreEqual(ie.Corners[0], ie2.Corners[0]);
            Assert.AreEqual(ie.Corners[1], ie2.Corners[1]);
            Assert.AreEqual(ie.Corners[2], ie2.Corners[2]);
            Assert.AreEqual(ie.Corners[3], ie2.Corners[3]);
        }
    }
}
